#!./strawberry

include("banners.pro").

?-
  X is scan(get_environment_arg(0, getenv("QUERY_STRING"))),
  go(X).

go(new):-
  say([[f,f,f],[f,f,f],[f,f,f]], "It's your move.", yes).

go(X):-
  Y is scan(get_environment_arg(1, getenv("QUERY_STRING"))), 
  Current_Pos is scan(get_environment_arg(2, getenv("QUERY_STRING"))), 
  member(Current_Pos, L, Y), 
  member(L, f, X), 
  !, 
  replace(L2, L, x, X), 
  replace(Current_Pos2, Current_Pos, L2, Y), 
  think(Current_Pos2).

think(Pos) :-
  try_to_win(Pos), !.
think(Pos) :-
  try_nolose(Pos), !.
think(Pos) :-
  say(Pos, "This game is equal.", no).

try_nolose(Pos) :-
  move(o, Pos, Sit2),
  nolose(x, Sit2), 
  say(Sit2, "It's your move.", yes). 
 
try_to_win(Pos) :- 
  move(o, Pos, Sit2), 
  is_it_win(Sit2). 
 
is_it_win(Sit2) :- 
  victory(o, Sit2), 
  say(Sit2, "Sorry but this time you lost.", no). 
is_it_win(Sit2) :- 
  win(x, Sit2), 
  say(Sit2, "Give up. You have no chance.", yes). 
 
member([Element, _, _], Element, 0). 
member([_, Element, _], Element, 1). 
member([_, _, Element], Element, 2). 

replace([Element, A, B], [_, A, B], Element, 0). 
replace([A, Element, B], [A, _, B], Element, 1). 
replace([A, B, Element], [A, B, _], Element, 2).
 
member2(Pos, El, X, Y):- 
  member(Pos, L, Y), 
  member(L, El, X). 
 
victory( Who, [[Who, Who, Who], [_, _, _], [_, _, _]]). 
victory( Who, [[_, _, _], [Who, Who, Who], [_, _, _]]). 
victory( Who, [[_, _, _], [_, _, _], [Who, Who, Who]]). 
victory( Who, [[Who, _, _], [Who, _, _], [Who, _, _]]). 
victory( Who, [[_, Who, _], [_, Who, _], [_, Who, _]]). 
victory( Who, [[_, _, Who], [_, _, Who], [_, _, Who]]). 
victory( Who, [[Who, _, _], [_, Who, _], [_, _, Who]]). 
victory( Who, [[_, _, Who], [_, Who, _], [Who, _, _]]). 
 
win( o, Sit) :- move(o, Sit, Sit2), win(x, Sit2). 
win( x, Sit) :- victory(o, Sit). 
win( x, Sit) :- not(nowin( x, Sit)). 
 
nowin(x, Sit) :- move(x, Sit, Sit2), nowin(o, Sit2). 
nowin( o, Sit) :- victory(x, Sit).
nowin(o, Sit) :- not(move(Sit)). % the last move belongs to X 
nowin(o, Sit) :- not(win(o, Sit)). 
 
lose( x, Sit) :- move(x, Sit, Sit2), lose(o, Sit2). 
lose( o, Sit) :- victory(x, Sit).
lose( o, Sit) :- not(nolose( o, Sit)). 
 
nolose(o, Sit) :- not(move(Sit)). % the last move belongs to X 
nolose(o, Sit) :- move(o, Sit, Sit2), nolose(x, Sit2). 
nolose( x, Sit) :- victory(o, Sit). 
nolose(x, Sit) :- not(lose(x, Sit)). 
 
move(P, Sit, Sit2) :-  
  member(Sit, L, Y), 
  member(L, f, X), 
  replace(L2, L, P, X), 
  replace(Sit2, Sit, L2, Y). 
 
move(Sit) :-  
  member(Sit, L, _), 
  member(L, f, _). 
 
say(Pos, Message, Continue):- 
  set_content_type("text/html"),
  write("<!doctype html public ""-//w3c//dtd html 4.0 transitional//en""> 
<html> 
<head>
   <meta http-equiv=""Content-Type"" content=""text/html; charset=windows-1251""> 
   <meta name=""Author"" content=""Dimiter Dobrev""> 
   <meta name=""GENERATOR"" content=""Mozilla/4.51 [en] (Win98; I) [Netscape]""> 
   <title>Tick-Tack-Toe</title> 
</head> 
<body text=""#FFFFCC"" bgcolor=""#282848"" link=""#FF0000"" vlink=""#FF9900"" alink=""#FFCC33"">"), 
 
  banner,
 
  write(" 
 <p> 
<center><table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=3 WIDTH=""1%"" >"), 
  for(Y, 0, 2), 
  write(" 
<tr>"), 
  for(X, 0, 2), 
  write(" 
<td>"),
  member2(Pos, El, X, Y),
  link(Continue, El, Pos, X, Y),
  write("<img SRC=""/games/Tick-Tack-Toe/"),
  write(El),
  write(".gif"" BORDER=0 height=50 width=50></a></td>
"),
  X=2,
  write("</tr>
"),
  Y=2,
  write("
</table></center>

<center>
<p>"),
write("<center><font size=+1>"),
write(Message),
write("</font></center><br><br><br>"),
( (Pos=[[f,f,f],[f,f,f],[f,f,f]]) ->
write("<img src=""/games/NewGame_dn.gif"" alt=""New Game"">");
write("<a href=""/cgi-bin/Tick-Tack-Toe.pro?new""><img src=""/games/NewGame_up.gif"" alt=""New Game"" border=0></a>") ),
write("<a href=""/games.html""><img src=""/games/BacktoGames_up.gif"" alt=""Back To Games"" border=0></a>"),
write("<a href=""/games/Tick-Tack-Toe/Rules_T3x3.html""><img src=""/games/Rules_up.gif"" alt=""Rules"" border=0></a>"),
write("<a href=""http://www.dobrev.com""><img src=""/games/SP_up.gif"" alt=""Strawberry Prolog"" border=0></a>"),
write("
<p><b><font color=""#33CCFF""><font size=+3>Tick-Tack-Toe</font></font></b></center>
<p><br><br><br>"),

 banner,

write("
</body>
</html>

").

link(yes, f, Pos, X, Y):- !,
  write("<a href=""/cgi-bin/Tick-Tack-Toe.pro?"),
  write(X),
  write("&"),
  write(Y),
  write("&"),
  write(Pos),
  write(""">").
link(_, _, _, _, _).

